# frozen_string_literal: true

class AlsIdUniqJob < ActiveJob::Base
 
  queue_as :critical
  unique :until_executed

  def perform(housing_request_id)
    if hr = Hermes::HousingRequest.find(housing_request_id)
      if Hermes::HousingRequest.only(:als_id).where(als_id: hr.als_id).count != 1
        hr.generate_als_id
        hr.save
      end 
    end 
  end
end