# frozen_string_literal: true

module Hermes
  class HousingRequestShareSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes %i[
      housing_request_id
      lessor_id
      code
      expire_at
      public_url
    ]

    type 'housing_request_shares'

    def lessor_id
      object.lessor_id&.to_s
    end

    def housing_request_id
      object.housing_request_id&.to_s
    end
    
  end
end
